﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;
private import map;
private import fmfloader;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count = 0;		// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score = 0;				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	enum MOTION{
		IDLE = 0,
		UP,
		DOWN,
		LEFT,
		RIGTH,
	};
	MOTION motion[2] = MOTION.IDLE;
	int anime[2] = 0;
	int anime_int[2] = 0;
	int anime_intdef[2] = 0;
	int anime_max[2] = 0;

	int push = 0;	//
	int seq = 0;	//アニメーションシーケンス
	int pushCount = 0;
	int map[200] = 0;
	int mapd[200] = 0;

	int hashi = 0;
	int hachi[3] = 0;
	int hebi[3] = 0;
	int iwa[5] = 0;
	int iwatimer[5] = 0;
	int ana[3] = 0;
	int kaminari = 0;
	int kaminaritimer = 0;
	int inputwait = 0;
	int bonus = 0;

	Keypad keypad;					// キーボード/ゲームパッド取得用
	
	//エフェクト用構造体
	struct EFFECT_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float pos_x;//位置
		float pos_y;//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
	};
	const int EFFECT_MAX = 128;
	EFFECT_DATA effect[EFFECT_MAX];
	
		struct TAMA_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float jumpforce;	//ジャンプ力
		float pos_x;//位置
		float pos_y;//位置
		float rot;	//角度
		float rotadd;	//角度
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
		int image_x;

		int anime;
		int anime_int[2];
	};

	const int AZUKI_MAX = 1024;
	TAMA_DATA azuki[AZUKI_MAX];

	const int RUNNING_MAX = 4;
	TAMA_DATA running[RUNNING_MAX];

	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("maptip","resource/image/maptip.bmp" , [0,255,0]);
		Hell_loadTexture("msg","resource/image/msg.bmp" , [0,255,0]);
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);
		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);
		Hell_loadTexture("serihu.bmp","resource/image/serihu.bmp" , [0,255,0]);

		Hell_loadTexture("bg2","resource/image/bg2.bmp" , [0,255,0]);

		Hell_loadTexture("player","resource/image/player.bmp" , [0,255,0]);

		Hell_loadWAV("step",         "resource/sound/punck_kick.wav");
		Hell_loadWAV("out",         "resource/sound/punch.wav");

//		loadFMF("resource/map/map.fmf");
//		map1 = new Map();
//		map1.init( this, layer1 );

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");

		game_time_count = 60 * 60;		//ゲーム終了までの残り時間

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;

		push = 0;	//
		seq = 0;	//アニメーションシーケンス
		pushCount = 0;

		Hell_stopBgm( 1000 );
		
		int i;
		for ( i = 0; i < 200; i++ )
		{
			if( i > 100 ) 
			{
				map[i] = 101;
			}
			else
			{
				map[i] = 0;
			}
		}
		for ( i = 0; i < 5; i++ )
		{
			iwatimer[i] = Hell_randInt(0, 10);
			iwa[i] = Hell_randInt(0, 6);
		}
		map[7] = 1;
		map[8] = 3;
		map[9] = 3;
		map[10] = 2;

		map[16] = 10;
		map[17] = 11;
		map[18] = 12;

		map[22] = 20;
		map[23] = 21;
		map[24] = 22;

		map[27] = 30;
		map[28] = 31;
		map[29] = 32;
		map[30] = 33;
		map[31] = 34;

		map[38] = 40;
		map[39] = 41;
		map[40] = 42;

		map[41] = 50;
		map[44] = 51;

		map[100] = 100;
		map[101] = 110;
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		stage_start_count++;
		if ( stage_start_count == ( 60 * 3 ) )
		{
			Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if (stage_start_count < (60 * 4))
		{
			Hell_drawTexture("msg"
				, 0+50
				, 0
				, 0
				, 0
				, getScreenWidth( ) , getScreenHeight( )
				, 1.0 , 1.0 );
		}
		int mx = 260;
		if ( stage_start_count < ( 60 * 1 ) )
		{
			Hell_drawFont(" 3 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 2 ) )
		{
			Hell_drawFont(" 2 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 3 ) )
		{
			Hell_drawFont(" 1 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( ( stage_start_count >= ( 60 * 3 ) ) && (stage_start_count < (60 * 4)))
		{
			Hell_drawFont("GO!" , mx, 180 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		timer++;
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;


		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 200, 130 , 4 , 255,255,255);
/*
		min = ( game_score / 60 ) / 60;
		sec = ( game_score / 60 ) % 60;
		msec = game_score % 60;
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );

*/
		int t = bonus;
		str = std.string.format( "%3d", t );
		Hell_drawFont( "TIME BONUS" ,    210, 180 , 2 , 255,255,255);
		Hell_drawFont( str , 260, 200 , 2 , 255,255,255);

		t = game_score;
		str = std.string.format( "%3d", t );
		Hell_drawFont( "SCORE" ,    210, 230 , 2 , 255,255,255);
		Hell_drawFont( str , 260, 250 , 4 , 255,255,255);

/*
		if ( hi_score >= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255,255,255);
		}
*/
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PRESS Z OR 1 BUTTON TO EXIT" , 100, 300 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" OWARI !" , 200, 320 , 4 , 255,255,255);
		}

	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			running_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			effect_move( );
			system_move( );
			SeneStart_move( );
//			map1.move( );
			azuki_move( );
			running_move( );

			break;
		case SCENE.CLEAR:
			//クリア
			effect_move( );
//			mob_move( );
			SeneClear_move( );
			azuki_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
//			map1.draw( );
			system_draw( );
			running_draw( );
			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
//			map1.draw( );
			system_draw( );
			effect_draw( );
			azuki_draw( );
			running_draw( );
			SeneStart_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
//			map1.draw( );
			system_draw( );
			effect_draw( );
			azuki_draw( );
			running_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
//			map1.draw( );
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
//			map1.draw( );
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		int input = -1;

		inputwait++;
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushRight())
			{
				if( pushCount < 102 )
				{
					pushCount++;
					inputwait = 0;
					Hell_playWAV( "step", 0, -1 );
				}
			}
			if(keypad.isPushLeft())
			{
				if( pushCount > 0 )
				{
					pushCount--;
					inputwait = 0;
					Hell_playWAV( "step", 0, -1 );
				}
			}
		}
		//スコア処理
		if ( pushCount > game_score )
		{
			game_score = pushCount;
		}
		
		//各オブジェクトの処理
		//橋
		int t = timer % 120;
		if ( ( t >= 0 ) && ( t < 60 ) )
		{
			hashi = 0;
		}
		if ( ( t >= 60 ) && ( t < 90 ) )
		{
			hashi = 1;
		}
		if ( ( t >= 90 ) && ( t < 120 ) )
		{
			hashi = 2;
		}
		//蜂
		int i;
		for( i = 0; i < 3; i++ )
		{
			hachi[i] = 0;
			t = ( timer + ( i * 20 ) ) % 100;
			if ( ( t >= 0 ) && ( t < 20 ) )
			{
				hachi[i] = 1;
			}
		}
		//蛇
		for( i = 0; i < 3; i++ )
		{
			hebi[i] = 0;
			t = ( timer + ( i * 10 ) ) % 70;
			if ( ( t >= 0 ) && ( t < 10 ) )
			{
				hebi[i] = 1;
			}
		}
		//岩
		for( i = 0; i < 5; i++ )
		{
			iwatimer[i]--;
			if( iwatimer[i] < 0 )
			{
				iwatimer[i] = 10;
				iwa[i]++;
				if( iwa[i] >= 5 )
				{
					iwa[i] = 0;
					iwatimer[i] = 10;
					if( Hell_randInt(0, 6) == 3 )
					{
						iwatimer[i] += 10;
					}
				}
			}
		}
		//穴
		for( i = 0; i < 3; i++ )
		{
			ana[i] = 0;
			t = ( timer + ( i * 30 ) ) % 120;
			if ( ( t >= 0 ) && ( t < 30 ) )
			{
				ana[i] = 1;
			}
		}
		//雷
		kaminaritimer--;
		if( kaminaritimer < 0 )
		{
			if ( kaminari == 0 )
			{
				kaminari = 1;
			}
			else
			{
				kaminari = 0;
			}
			kaminaritimer = 10 + Hell_randInt(0, 60);
		}

		//今いるマスの生存判定
		bool start = false;
		switch( map[pushCount] )
		{
		case 1:
		case 2:
		case 3:
			//橋
			if( hashi != 0 )
			{
				//落下
				start = true;
				mapd[6] = 1;
			}
			break;
		case 10:
		case 11:
		case 12:
			if ( hachi[map[pushCount] - 10] != 0 )
			{
				start = true;
				mapd[pushCount] = 1;
			}
			break;
		case 20:
		case 21:
		case 22:
			if ( hebi[map[pushCount] - 20] != 0 )
			{
				start = true;
				mapd[pushCount] = 1;
			}
			break;
		case 30:
		case 31:
		case 32:
		case 33:
		case 34:
			if ( iwa[map[pushCount] - 30] == 4 )
			{
				start = true;
				mapd[pushCount] = 1;
			}
			break;
		case 40:
		case 41:
		case 42:
			if ( ana[map[pushCount] - 40] != 0 )
			{
				start = true;
				mapd[37] = 1;
			}
			break;
		case 50:
			if( kaminari == 0 )
			{
				start = true;
				mapd[pushCount] = 1;
			}
			break;
		case 51:
			if( kaminari == 1 )
			{
				start = true;
				mapd[pushCount] = 1;
			}
			break;
		case 110:
			{
				start = true;
				mapd[100] = 1;
			}
			break;
		default:
			break;
		}
//		start = false;
		if( start == true )
		{
			//スタートへ戻る
			pushCount = 0;
//			pushCount = 50;
			Hell_playWAV( "out", 0, -1 );
		}

		
		
		//残り時間のカウント
		game_time_count--;
		if ( ( game_time_count == 0 ) || ( ( map[pushCount] == 100 ) && ( inputwait > 30 ) ) )
		{
			//ボーナス
			bonus = (game_time_count / 60);
			game_score += bonus;
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
//			game_score = game_time_count;
			if ( hi_score > game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
/*
		if ( pushCount >= 180 )
		{
			Hell_stopBgm(0);
			Hell_playWAV( "bomb", 0, -1 );
			int j = 0;
			for ( j = 0; j < 128; j++ )
			{
				float spd = Hell_randInt(0, 8);
				int dir = Hell_randInt(0, 180);
				create_azuki( 0, SCR_W / 2, SCR_H / 2, dir, spd, -Hell_randInt(-10, +50) );
			}
			float spd = Hell_randInt(2, 5);
			create_azuki( 1, SCR_W / 2, SCR_H / 2, 45, spd, -Hell_randInt(30, +40) );
			spd = Hell_randInt(2, 5);
			create_azuki( 2, SCR_W / 2, SCR_H / 2, 180-45, spd, -Hell_randInt(30, +40) );
			
//			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
			game_score = game_time_count;
			if ( hi_score > game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
*/		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
		
		timer++;

	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		int i;
		int j;
		
		Hell_drawTextureEx("bg2"
			, SCR_W / 2, SCR_H / 2
			, 0, 0
			, SCR_W, SCR_H );

		//マップ描画
		for ( i = 0; i < 20; i++ )
		{
			int ani = 0;
			switch( map[i+pushCount] )
			{
			case 0:	//地面
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 0, 64 + ( mapd[i+pushCount] * 32 )
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 + 32
					, 0, 64
					, 32, 32 );
				break;
			case 1:	//木の橋
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 32, 64 + ( hashi * 32 )
					, 32 * 4, 32 );
				break;
			case 2:	//木の橋
				Hell_drawTexture("maptip"
					, ( i - 3 ) * 32, 300
					, 32, 64 + ( hashi * 32 )
					, 32 * 4, 32 );
				break;
			case 3:	//木の橋（表示なし）
				break;
			case 10:	//蜂
			case 11:	//蜂
			case 12:	//蜂
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 0, 64 + ( mapd[i+pushCount] * 32 )
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 + 32
					, 0, 64
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 - ( 64 )
					, 32 * 5, 64 + ( 32 * hachi[map[i + pushCount] - 10] )
					, 32, 32 );
				break;
			case 20:	//へび
			case 21:	//へび
			case 22:	//へび
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 0, 64 + ( mapd[i+pushCount] * 32 )
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 + 32
					, 0, 64
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 - ( 64 )
					, 32 * 6, 64 + ( 32 * hebi[map[i + pushCount] - 20] )
					, 32, 32 );
				break;
			case 30:	//岩
			case 31:	//岩
			case 32:	//岩
			case 33:	//岩
			case 34:	//岩
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 0, 64 + ( mapd[i+pushCount] * 32 )
					, 32, 32 );
					
				Hell_drawTexture("maptip"
					, i * 32, 300 + 32
					, 0, 64
					, 32, 32 );
				for ( j = 0; j < 5; j++ )
				{	
					Hell_drawTexture("maptip"
						, i * 32, 300 - ( 64 ) - ( 32 * 4 ) + ( j * 32 )
						, 32 * 7, 64
						, 32, 32 );
				}
				if( iwa[map[i + pushCount] - 30] < 6 )
				{
					Hell_drawTexture("maptip"
						, i * 32, 300 - ( 64 ) - ( 32 * 4 ) + ( iwa[map[i + pushCount] - 30] * 32 )
						, 32 * 7, 64 + 32
						, 32, 32 );
				}
				break;
			case 40:	//穴
			case 41:	//穴
			case 42:	//穴
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 32 * 8, 64 + ( 32 * ana[map[i + pushCount] - 40] )
					, 32, 32 );
				break;
			case 50:	//雷
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 0, 64 + ( mapd[i+pushCount] * 32 )
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 + 32
					, 0, 64
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 - ( 64 )
					, 32 * 9, 64 + ( 32 * 0 )
					, 32, 32 );
				if ( ( kaminari == 0 ) && ( ( timer % 4 ) < 2 ) )
				{
					Hell_drawTexture("maptip"
						, i * 32, 300 - ( 64 )
						, 32 * 9, 64 + ( 32 * 1 )
						, 32, 32 );
				}
				break;
			case 51:	//雷
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 0, 64 + ( mapd[i+pushCount] * 32 )
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 + 32
					, 0, 64
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 - ( 64 )
					, 32 * 9, 64 + ( 32 * 0 )
					, 32, 32 );
				if ( ( kaminari == 1 ) && ( ( timer % 4 ) < 2 ) )
				{
					Hell_drawTexture("maptip"
						, i * 32, 300 - ( 64 )
						, 32 * 9, 64 + ( 32 * 1 )
						, 32, 32 );
				}
				break;
			case 100:	//ゴール
				Hell_drawTexture("maptip"
					, i * 32, 300
					, 0, 64 + ( mapd[i+pushCount] * 32 )
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 + 32
					, 0, 64
					, 32, 32 );
				Hell_drawTexture("maptip"
					, i * 32, 300 - ( 32 )
					, 32 * 10, 64
					, 32, 32 );
				break;
			default:
				break;
			}
		}

			
		//プレイヤーの描画	
		int ani = pushCount % 4;
		if( iSceneStatus == SCENE.CLEAR )
		{
			if( map[pushCount] == 100 )
			{
				ani = 4 + ( ( timer / 3 ) % 2 );
			}
			else
			{
				ani = 6 + ( ( timer / 3 ) % 2 );
			}
		}
		Hell_drawTexture("maptip"
			, 0, 300 - 32
			, 0 + ( ani * 32 ), 0
			, 32, 32 );
			
			
		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %2d:%02d:%02d", min, sec, msec );
		}
	

//		str = std.string.format( "%dm", player_x );
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 200, 3 , 3 , r,g,b);

		int t = ( game_score );
		str = std.string.format( "%3d", t );
		Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);
		Hell_drawFont( str , 10, 30 , 2 , 255,255,255);

/*
		min = ( hi_score / 60 ) / 60;
		sec = ( hi_score / 60 ) % 60;
		msec = hi_score % 60;

		Hell_drawFont( "HI SCORE" , 300, 10 , 2 , 255,255,255);
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);
*/	
	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
	//-----------------------------------------------------------------------------
	//	FMFファイルの読み込み
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
/*
	void loadFMF(char[] filepath)
	{
		scope fmf = new FMFLoader(filepath);
		layer1 = fmf.getLayer(0); // 地形
		Hell_write(layer1.width);
		Hell_write(layer1.height);
		Hell_write(layer1.chip_width);
		Hell_write(layer1.chip_height);
	}
*/
	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_effect( int type, float x, float y, float dir, float speed )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//
				
				//タイプによってパラメータを分けるといいかも
				effect[i].r = 255;	//色
				effect[i].g = 255;	//色
				effect[i].b = 255;	//色
				effect[i].zoom_x = 1.0;	//拡大率
				effect[i].zoom_y = 1.0;	//拡大率
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
//				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("player"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 32 + ( 32 * effect[i].type )
					, 128, 32
					, effect[i].zoom_x , effect[i].zoom_y
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_cosEx( effect[i].dir ) * effect[i].speed;
				float vy = Hell_sinEx( effect[i].dir ) * effect[i].speed;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置

				//タイプによって動きを分けるといいかも
				if (effect[i].timer > 60 )
				{
					effect[i].exist = 0;
				}
			}
		}
	}

	//-----------------------------------------------------------------------------
	//	小豆の作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_azuki( int type, float x, float y, float dir, float speed, float jumpforce )
	{
		int i = 0;
		for ( i = 0; i < AZUKI_MAX; i++ )
		{
			if ( azuki[i].exist == 0 )
			{
				azuki[i].exist = 1;	//存在
				azuki[i].type = type;	//
				azuki[i].timer = 0;	//生存時間
				azuki[i].pos_x = x;	//位置
				azuki[i].pos_y = y;	//位置
				azuki[i].alpha = 255;	//透明度
				azuki[i].dir = dir;	//
				azuki[i].speed = speed;	//
				azuki[i].rot = Hell_randInt(0, 360);	//
				azuki[i].rotadd = Hell_randInt(0, 90)-45;	//
				azuki[i].jumpforce = jumpforce;
				
				//タイプによってパラメータを分けるといいかも
				azuki[i].r = 255;	//色
				azuki[i].g = 255;	//色
				azuki[i].b = 255;	//色
				azuki[i].zoom_x = 1;	//拡大率
				azuki[i].zoom_y = 1;	//拡大率
				azuki[i].image_x = 0;
				break;
			}
		}
	}
	//エフェクトの表示
	void azuki_draw( )
	{
		int i = 0;
		for ( i = 0; i < AZUKI_MAX; i++ )
		{
			if ( azuki[i].exist != 0 )
			{
				switch ( azuki[i].type )
				{
				case 0:
					Hell_drawCircle(azuki[i].pos_x, azuki[i].pos_y, 2, 0, 255, 0, 0, 255);
					break;
				case 1:
					Hell_drawTextureEx("maptip"
						, azuki[i].pos_x, azuki[i].pos_y
						, 64, 0
						, 64, 64
						, 1.0f, 1.0f, azuki[i].rot );
					break;
				case 2:
					Hell_drawTextureEx("maptip"
						, azuki[i].pos_x, azuki[i].pos_y
						,128, 0
						, 64, 64
						, 1.0f, 1.0f, azuki[i].rot );
					break;
				default:
					break;
				}
			}
		}
	}
	//エフェクトの移動
	void azuki_move( )
	{
		int i = 0;
		for ( i = 0; i < AZUKI_MAX; i++ )
		{
			if ( azuki[i].exist != 0 )
			{
				azuki[i].timer++;	//生存時間

				azuki[i].jumpforce += 0.98;
				float vx = Hell_cosEx( azuki[i].dir ) * azuki[i].speed;
				float vy = Hell_sinEx( azuki[i].dir ) * azuki[i].speed;
				azuki[i].pos_x += vx;	//位置
				azuki[i].pos_y += vy + ( azuki[i].jumpforce / 3 );	//位置
//				azuki[i].pos_y += vy;	//位置
				azuki[i].rot += azuki[i].rotadd;
				
				if ( azuki[i].jumpforce > 0 )
				{
					if ( azuki[i].pos_y > 400 )
					{
						azuki[i].exist = 0;
					}
				}
			}
		}
	}


	//-----------------------------------------------------------------------------
	//	少年の作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_running( int type, float x, float y, float dir, float speed )
	{
		int i = 0;
		for ( i = 0; i < RUNNING_MAX; i++ )
		{
			if ( running[i].exist == 0 )
			{
				running[i].exist = 1;	//存在
				running[i].type = type;	//
				running[i].timer = 0;	//生存時間
				running[i].pos_x = x;	//位置
				running[i].pos_y = y;	//位置
				running[i].alpha = 255;	//透明度
				running[i].dir = dir;	//
				running[i].speed = speed;	//
				running[i].rot = Hell_randInt(0, 360);	//
				running[i].rotadd = Hell_randInt(0, 90)-45;	//
				
				//タイプによってパラメータを分けるといいかも
				running[i].r = 255;	//色
				running[i].g = 255;	//色
				running[i].b = 255;	//色
				running[i].zoom_x = 1;	//拡大率
				running[i].zoom_y = 1;	//拡大率
				running[i].image_x = 0;

				running[i].anime = Hell_randInt(0, 6);
				running[i].anime_int[0] = 7 - cast(int)speed;
				running[i].anime_int[1] = running[i].anime_int[0];
				break;
			}
		}
	}
	//エフェクトの表示
	void running_draw( )
	{
		{
			//キャラの表示
			

		}

		int i = 0;
		for ( i = 0; i < RUNNING_MAX; i++ )
		{
			if ( running[i].exist != 0 )
			{
				int sx = 0;
				int sy = 0;
				int sizex = 128;
				int sizey = 128;
				int ani = running[i].anime % 6;
				switch ( running[i].type )
				{
				case 0:
					Hell_drawTextureEx("maptip"
						, running[i].pos_x, running[i].pos_y
						, sizex * ani, 128
						, 128, 128 );
					break;
				case 1:
					Hell_drawTextureEx("maptip"
						, running[i].pos_x, running[i].pos_y
						, sizex * ani, 0
						, 128, 128 );
					break;
				default:
					break;
				}
			}
		}
	}
	//エフェクトの移動
	void running_move( )
	{
		int i = 0;
		
		for ( i = 0; i < RUNNING_MAX; i++ )
		{
			if ( running[i].exist != 0 )
			{
				running[i].timer++;	//生存時間

				float vx = Hell_cosEx( running[i].dir ) * running[i].speed;
				float vy = Hell_sinEx( running[i].dir ) * running[i].speed;
				running[i].pos_x += vx;	//位置
				running[i].pos_y += vy;	//位置
//				running[i].rot += running[i].rotadd;

				if( running[i].pos_x > ( 640 + 70 ) )
				{
					running[i].pos_x = -70;
					running[i].pos_y = 160 + ( i * 40 ) +  Hell_randInt(0, 35);
					running[i].speed = Hell_randInt(2, 4);
					running[i].anime_int[0] = 7 - cast(int)running[i].speed;
					running[i].anime_int[1] = running[i].anime_int[0];
					running[i].type = Hell_randInt(0, 2);
				}


				running[i].anime_int[1]--;
				if( running[i].anime_int[1] == 0 )
				{
					running[i].anime_int[1] = running[i].anime_int[0];
					running[i].anime++;
					if( running[i].anime >= 6 )
					{
						running[i].anime = 0;
					}
				}
				
			}
		}
	}


}


